;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME:vraidate
;
; PURPOSE:donne la date en long et avec le siecle s'il n'est pas specifie.
;
; CATEGORY:compatibile an 2000 bien-sur
;
; CALLING SEQUENCE:res=varidate(date)
;
; INPUTS:date:une date vairmer du type yymmdd ou yyyymmdd
;
; KEYWORD PARAMETERS:
;       VRAIDATE: pour ne pasa transformer l''annnee 01 en 1901 
;
; OUTPUTS:une date vairmer du type yyyymmdd
;
; SIDE EFFECTS:si year est nulle ou egale a -1 ne change rien
;
; EXAMPLE:vraidate(980703) donne 19980703 qui est un long
;
; MODIFICATION HISTORY: Sebastien Masson (smasson@lodyc.jussieu.fr)
;			3/7/98
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
function vraidate, date, VRAIDATE = vraidate, _EXTRA = ex
;------------------------------------------------------------
   date=long(date)
   annee=date/10000
   if keyword_set(VRAIDATE) then return, date ELSE $
   return, date+19000000*(annee ne 0 and annee ne -1 and date lt 1000000 and date GT 0)
;------------------------------------------------------------
end
